<?php
// PHP script for contact page that doesn't reveal email addresses or allow
// user input of destination email.
//
// Copyright (C) 2004, Aubrey Turner (http://www.aubreyturner.org)
//
// You may freely modify and redistribute this code, provided that this copyright
// notice remains intact.
//
// Release:  1.1 (20040719)
//
//  Change history:
//	1.0	20040709	- Initial release
//	1.1	20040719	- Added code to work around magic_quotes_gpc() situation (i.e. remove unneeded quotes)
//				- Added call to 'htmlspecialchars()' for name and subject fields



require("continfo.php");

$form_css=$base_url.$css_name;

$php_self = $_SERVER["PHP_SELF"];
$remote_ip = $_SERVER["REMOTE_ADDR"];

// Translateable messages 
$tags=array("subject_header" => "Contact Form: ",
	    "instructions"   => "<p>To contact me please fill in the following fields and hit \"Submit\".</p>",
	    "name"           => "Your name:&nbsp; ",
	    "email"          => "* Email address:&nbsp; ",
	    "subject"        => "* Subject:&nbsp; ",
	    "text"           => "* Text:<br />",
	    "required"       => "* denotes a required field.<br /><br />",
	    "close"          => "Close this window.",
	    "error"          => "Your message could not be sent because of the following problem(s):",
	    "sent"           => "Your message has been sent.",
	    "doc_1"          => "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n",
	    "doc_2"          => "<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\">\n"
	    );

// Error messages:
$error_tags = array("badtarget"  => "Form generator: Unknown target for email.",
		    "invocation" => "Unsupported invocation method.",
		    "subject"    => "The subject field is required.",
		    "reply"      => "A reply email address is required.",
		    "text"       => "You must specify some text.<br />",
		    "system"     => "There was a system error while attempting to send the message."
		);

// End changeable values

$target_email_tag="";
$error_message="";
$mail_sent=0;
$user_email="";

// Spew some headers/CSS...
print($tags["doc_1"]);
print($tags["doc_2"]);
print("<head>\n");
print("<title>".$page_title."</title>\n");
print("<link rel='stylesheet' type='text/css' media='all' href=\"".$form_css."\" />\n");
print("<style type='text/css' media='screen'>@import \"".$form_css."\";</style>\n");
print("<div id=\"wrapper\">\n");
print("<div id=\"blogtitle\"><h1>".$page_title."</h1></div>\n");

// Get method invoked in "GET" form to display form
if($_SERVER["REQUEST_METHOD"] == "GET")
{
	$target_email_tag = $_GET["target"];
	if($contacts[$target_email_tag]=="")
	{
		print($error_tags["badtarget"]);
		exit;
	}

	// Prepare form generation variables... (if needed)
}
else
{
	// Process form...
	if($_SERVER["REQUEST_METHOD"]!="POST")
	{
		print($error_tags["invocation"]);
		exit;
	}
	// Get parameters from $_POST array:
	//	
	if(get_magic_quotes_gpc())
	{
		$target_email_tag = stripslashes($_POST["target"]);
		$subject = stripslashes($_POST["contact_subject"]);
		$reply_email = stripslashes($_POST["reply"]);
		$body = stripslashes($_POST["body"]);
		$user_name = stripslashes($_POST["user_name"]);
	}
	else
	{
		$target_email_tag = $_POST["target"];
		$subject = $_POST["contact_subject"];
		$reply_email = $_POST["reply"];
		$body = $_POST["body"];
		$user_name = $_POST["user_name"];
	}

	if($contacts[$target_email_tag]=="")
	{
		print($error_tags["badtarget"]);
		exit;
	}

	if($subject=="")
	{
		$error_message.="&nbsp;&nbsp;&nbsp;".$error_tags["subject"]."<br />";
	}

	if($reply_email=="")
	{
		$error_message.="&nbsp;&nbsp;&nbsp;".$error_tags["reply"]."<br />";
	}

	if($body=="")
	{
		$error_message.="&nbsp;&nbsp;&nbsp;".$error_tags["text"]."<br />";
	}

	if($error_message=="")
	{
		if($user_name!="")
		{
			$from_line = "From: ".$user_name." <".$reply_email.">";
		}
		else
		{
			$from_line = "From: ".$reply_email;
		}

		$rc = mail($contacts[$target_email_tag], 
			$tags["subject_header"].$subject,
			"Message from IP:".$remote_ip."\n\n".$body,
			$from_line);

		if($rc==FALSE)
		{
			$error_message.="&nbsp;&nbsp;&nbsp;".$error_tags["system"]."<br />\n";
		}
		$mail_sent=1;
	}
}

// Show form (if necessary)
if($mail_sent==0)
{
	print($tags["instructions"]);
	print("<br />\n");
	print("<hr width=\"100%\" />\n");

	if($error_message!="")
	{
		print("<div class=\"errorheading\">".$tags["error"]."</div>\n");
		print("<div class=\"errormessage\">".$error_message."</div>\n");
	}

	// main form header (fill in values if known)
	print ("<form method=\"post\" action=\"".$php_self."\">\n");
	print ("<input type=\"hidden\" name=\"target\" value=\"".$target."\" />\n");

	print ("<div class='itemWrapper'>\n");
	print ($tags["name"]);
	print ("<input type=\"text\" name=\"user_name\" value=\"".htmlspecialchars($user_name)."\" class=\"input\" maxlength=\"128\" size=\"48\" /><br />\n");
	print ("</div>\n");

	print ("<div class='itemWrapper'>\n");
	print ($tags["email"]);
	print ("<input type=\"text\" name=\"reply\" value=\"".$reply_email."\" class=\"input\" maxlength=\"128\" size=\"44\" /><br />\n");
	print ("</div>\n");
	print ("<div class='itemWrapper'>\n");
	print ($tags["subject"]);
	print ("<input type=\"text\" name=\"contact_subject\" value=\"".htmlspecialchars($subject)."\" class=\"input\"  maxlength=\"128\" size=\"50\" /><br />\n");
	print ("</div>\n");
	print ("<div class='itemWrapper'>\n");
	print ($tags["text"]);
	print ("<textarea name=\"body\" id=\"body\" cols=\"80\" rows=\"12\" class=\"textarea\">\n");
	print ($body);
	print ("</textarea>\n</div>\n");

	print ($tags["required"]);

	// end of form...
	print ("<input type=\"submit\" value=\"submit\" class=\"submit\" />\n");
	print ("</form>\n");
	print ("<a href=\"javascript:window.close();\">".$tags["close"]."</a>\n");
}
else
{
	print ($tags["sent"]."<br /><br />\n");
	print ("<a href=\"javascript:window.close();\">".$tags["close"]."</a>\n");
}

?>
</div>
</body>
</html>
